<template>
  <div data-view="register">
    <layout-auth-frame>
      <template slot="content">
        <v-layout
          v-if="!isExisting"
          class="form-wrapper normal"
        >
          <AbsoluteBox
            :top="stepBoxPos.top"
            :right="stepBoxPos.right"
          >
            <div class="step-counter">
              {{ 'Step ' + step + ' of ' + steps }}
            </div>
          </AbsoluteBox>
          <UserProfileForm
            v-if="!isSecondStepActive"
            :user-profile="userProfile"
            :on-submit="onGetUserProfile"
          />
          <BusinessProfileForm
            v-else
            :business-profile="businessProfile"
            :is-loading="isLoading"
            :has-recaptcha="true"
            cancel-trigger-label="Back"
            :on-cancel="onDisplayUserProfile"
            :on-submit="onGetBusinessProfile"
          />
        </v-layout>
      </template>
    </layout-auth-frame>
  </div>
</template>

<script>
  import UserProfileForm from '../../components/forms/auth/UserProfile';
  import BusinessProfileForm from '../../components/forms/auth/BusinessProfile';
  import AbsoluteBox from '../../components/layout/AbsoluteBox';

  export default {
    components: {
      AbsoluteBox,
      UserProfileForm,
      BusinessProfileForm
    },
    data() {
      return {
        stepBoxPos: {
          top: 58,
          right: 0
        },
        userProfile: {
          firstName: '',
          lastName: '',
          title: '',
          email: '',
          password: '',
          language: 'en',
          timezone: 1
        },
        businessProfile: {
          name: '',
          shopUrl: '',
          invoiceEmail: '',
          address: '',
          secondAddress: '',
          city: '',
          state: '',
          zipCode: '',
          country: 'de'
        },
        step: 1,
        steps: 2,
        isTypeDetermined: false,
        isExisting: false,
        isSecondStepActive: false,
        isLoading: false,
        isSubmitted: false
      };
    },
    created() {
      this.$watch(() => {
        const user = this.$store.getters['auth/user'];
        const hasErrors = this.$store.getters['alerts/error'].length > 0;

        this.watchUser(user);

        if (hasErrors && this.isSubmitted) {
          this.isLoading = false;
          this.isSubmitted = false;
        }
      });
    },
    methods: {
      onGetUserProfile(userProfile) {
        this.userProfile = userProfile;
        this.isSecondStepActive = true;
        this.step = 2;
      },
      onGetBusinessProfile(businessProfile) {
        this.businessProfile = businessProfile;
        this.createAccount();
      },
      onDisplayUserProfile() {
        this.isSecondStepActive = false;
        this.step = 1;
      },
      createAccount() {
        const { token } = this.$route.params;
        const { firstName, lastName, title, email, password, language, timezone } = this.userProfile;
        const { name, shopUrl, invoiceEmail, address, secondAddress, city, state, zipCode, country, recaptcha } = this.businessProfile;

        const user = {
          firstname: firstName,
          lastname: lastName,
          email,
          token,
          password,
          employee: title,
          address,
          address_opt: secondAddress,
          city,
          state,
          zip: zipCode,
          country,
          invoice_email: invoiceEmail,
          name,
          url: shopUrl,
          language,
          timezone,
          'g-recaptcha-response': recaptcha
        };

        this.isLoading = true;
        this.isSubmitted = true;
        return this.$store.dispatch('auth/register', user);
      },
      watchUser(user) {
        const { firstname, lastname, email, language } = user;
        const { firstName } = this.userProfile;

        if (firstname !== firstName) {
          this.userProfile = {
            ...this.userProfile,
            firstName: firstname,
            lastName: lastname,
            email,
            language
          };
        }
      }
    },
    metaInfo() {
      return {
        title: this.$t('views.register.title')
      };
    }
  };
</script>

<style lang="stylus" scoped>
  [data-view="register"] {
    .form-wrapper {
      position: relative;
    }

    .step-counter {
      font-size: 16px;
    }
  }
</style>
